;  AVTOTIME   PIC16F84  
;   ,    
;       
; -2106  .
; 
; : ..  
; :  27.03.2001
;
;  =32768 

        list    p=16f84
        #include p16f84.inc
					;  ,   .
					; . . .,  
        __CONFIG        _LP_OSC & _PWRTE_ON & _WDT_ON & _CP_ON

;
FLAG    equ     H'0C'		;  
SET1S  equ     H'0'		;   FLAG
COUNT   equ     H'0D'		;  
DATAX   equ     H'0E'		;  
PUSH    equ     H'0F'		;    W
DEL0    equ     H'10'		;  0 
DEL1    equ     H'11'		;  1 

;
DATATIM equ     H'81'		;NNh-. .  (FFh-NNh)
DATAD0  equ     H'27'	   	; /  20
DATAD1  equ     H'0C'   	; /  x 

        org 0			; 
        goto init

        org 4			; 
        goto interupt


;   
init
        clrwdt			;  
        clrw			; W=0
        movwf   FLAG		; FLAG=0
        movwf   COUNT		; COUNT=0
        iorlw   H'55'		; W=55
        movwf   DATAX		; DATAX=55
        movlw   DATATIM  	; W=. . 
        movwf   TMR0		;  
        bsf     STATUS,RP0   	; .  1
        movlw   B'11110011'  	;  RA2 RA3  
        movwf   TRISA 
        movlw   B'11000101'  	; . . = 64
        movwf   OPTION_REG
        movlw   B'10100000'  	; . .
        movwf   INTCON
        bcf     STATUS,RP0 	; .  0

;  
main
        clrwdt			;  
        btfss   FLAG,SET1S	;  1 ?
        goto main			; 

        bcf     FLAG,SET1S	; ,   SET1S
        movf    DATAX,W		; W=DATAX
        movwf   PORTA		; PORTA=W
met1
        call d20ms		; . 20 
        clrw			; 
        movwf   PORTA		; PORTA
met2
        goto    main		; 	

;    
interupt
        movwf   PUSH		;  W
        bsf     FLAG,SET1S	;   SET1S
        incf    COUNT,F		;    1
        movf    DATAX,W		; W=DATAX
        xorlw   H'0ff'		;  W
        movwf   DATAX		; DATAX=W

; .   1
	movlw   DATAD1		; W=DATAD1
	movwf   DEL1		; DEL1=W
dopdel
	clrwdt			;  
	decfsz  DEL1,F		; DEL1 = 0 ?
	goto dopdel
	nop				;  
	nop

        movlw   DATATIM      	;  
        movwf   TMR0
        bcf     INTCON,T0IF	;   .
	movf    PUSH,W		;  W
	retfie			;   

;    20
d20ms	
	movlw   DATAD0		; W=DATAD0
	movwf   DEL0		; DEL0=W
d20ms1
	clrwdt			;  
	decfsz  DEL0,F		; DEL0 = 0 ?
	goto d20ms1			; 
	return			; -  /

        end

